import { ActionReducer } from '@ngrx/store';
import { UseStore } from 'idb-keyval';
import { NgrxStoreIdbOptions } from './ngrx-store-idb.options';
import { NgrxStoreIdbService } from './ngrx-store-idb.service';
/**
 * Default marshaller saves the whole store state
 */
export declare const defaultMarshaller: (state: any) => any;
export declare const defaultUnmarshaller: (state: any, rehydratedState: any) => unknown;
export declare const DEFAULT_OPTS: NgrxStoreIdbOptions;
/**
 * This is the main factory that creates our metareducer.
 */
export declare const metaReducerFactoryWithOptions: (options: NgrxStoreIdbOptions, idbStore: UseStore, service: NgrxStoreIdbService) => (reducer: ActionReducer<any>) => (state: any, action: any) => any;
export declare const optionsFactory: (options: Partial<NgrxStoreIdbOptions>) => NgrxStoreIdbOptions;
export declare const idbStoreFactory: (opts: NgrxStoreIdbOptions) => UseStore;
export declare const ngrxStoreIdbServiceInitializer: (opts: NgrxStoreIdbOptions, service: NgrxStoreIdbService) => () => Promise<boolean>;
