import { Action, Store } from '@ngrx/store';
import { UseStore } from 'idb-keyval';
import { Observable } from 'rxjs';
import { NgrxStoreIdbOptions } from './ngrx-store-idb.options';
import * as i0 from "@angular/core";
export interface NgrxStoreIdbSyncEvent {
    action: Action;
    success: boolean;
}
/**
 * This service emits events each time NgrxStoreIdb metareducer successfuly
 * syncs data to IndexedDB. The data emited from onSync$ observable is
 * the action that triggered the synchronisation event.
 */
export declare class NgrxStoreIdbService {
    private opts;
    private idbStore;
    private readonly uniqueKey;
    private syncSubject;
    private onSync$;
    private rehydrateSubject;
    private onRehydrate$;
    private lockAcquiredSubject;
    private onLockAcquired$;
    private iAmMasterOfStore;
    private timerSubscription;
    constructor(opts: NgrxStoreIdbOptions, idbStore: UseStore);
    acquireLock<T>(storeToRehydrate: Store<T>): Observable<boolean>;
    releaseLock(): Observable<void>;
    onLockAcquired(): Observable<boolean>;
    canConcurrentlySync(): boolean;
    private uuidv4;
    broadcastSyncEvent(action: Action): void;
    broadcastRehydrateEvent(state: any): void;
    onSync(): Observable<Action>;
    onRehydrate(): Observable<any>;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgrxStoreIdbService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<NgrxStoreIdbService>;
}
